import App from './src/app';
import * as Config from "./src/modules/Config";

const app = new App();

app.start();

export function init(appKey) {
    Config.setAppKey(appKey)
}

export function setAutoPageView(autoPageView) {
    app.pushAction('setAutoPageView', autoPageView);
}

export function trackPageView(url, referrer) {
    app.pushAction('trackPageView', url, referrer);
}


export function trackEvent(category, action, label, value) {
    app.pushAction('trackEvent', category, action, label, value);
}

export function sendEvent(eventId, params) {
    app.pushAction('sendEvent', eventId, params);
}

export function setLogHandler(logHandler) {
    app.pushAction('setLogHandler', logHandler);
}

export function actionTimeStart(action, extdata) {
    app.pushAction('actionTimeStart', action, extdata);
}

export function actonTimeEnd(action) {
    app.pushAction('actionTimeEnd', action);
}

export function setUserId(userId) {
    app.pushAction('setUserId', userId);
}

export function setChannel(channel) {
    app.pushAction('setChannel', channel);
}

export function setUserProperties(properties) {
    app.pushAction('setUserProperties', properties)
}

export function setVersion(version) {
    app.pushAction('setVersion', version);
}


function push_action_with_items(action, itemOrArray) {
    let items;
    if (typeof itemOrArray === 'object') {
        items = itemOrArray;
    }
    else {
        items = [itemOrArray];
    }

    for (let i = 0; i < items.length; i++) {
        app.pushAction(action, items[i]);
    }
}

export function recActionExpose(item) {
    push_action_with_items('recActionExpose', item);
}

export function recActionView(item) {
    push_action_with_items('recActionView', item);
}

export function recActionTransact(item) {
    push_action_with_items('recActionTransact', item);
}

export function recActionCollect(item) {
    push_action_with_items('recActionCollect', item);
}

export function recActionUncollect(item) {
    push_action_with_items('recActionUncollect', item);
}

export function recActionLike(item) {
    push_action_with_items('recActionLike', item);
}

export function recActionDislike(item) {
    push_action_with_items('recActionDislike', item);
}
