import * as LocalData from "./LocalData";
import * as Utils from './Utils';
const DEVICE_ID_KEY = "cidata_uid";


let uid = null;

function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    }

    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
        s4() + '-' + s4() + s4() + s4();
}

export function getDeviceId() {
    if (!Utils.isStringEmpty(uid)) {
        return uid;
    }
    uid = LocalData.getItem(DEVICE_ID_KEY);
    if (Utils.isStringEmpty(uid)) {
        uid = guid();
    }
    return uid;
}

export function setDeviceId(deviceId) {
    uid = deviceId;
    LocalData.setItem(DEVICE_ID_KEY, deviceId);
}
